#include<stdio.h>
#include<stdlib.h>
#include "llist.h"

int main(){
	puts("Constructing list manually...");
	NODE *two = construct(5, NULL);
	NODE *one = construct(1, two);
	NODE *root = construct(3, one);
	print_list(root);
	puts("Adding 7 to end...");
	add_to_end(root, 7);
	print_list(root);
	printf("Now it is %d elements long.\n", length(root));
	printf("The head is at %p.\n", root);
	puts("Adding 6 to the beginning and 8 at index 2...");
	insert_node(root, 0, 6);
	insert_node(root, 2, 8);
	print_list(root);
	printf("The head is still at %p.\n", root);
	puts("Searching for 5...");
	NODE_INT target = search(root, 5);
	printf("I found it at index %d.\n", target.num);
	fputs("The number I found there was: ", stdout);
	print_node(target.node);
	target = traverse(root, 3);
	fputs("At index 3 there is: ",stdout);
	print_node(target.node);
	puts("Deleting the element at index 3...");
	delete_node_at(root, 3);
	fputs("Now it's garbage: ",stdout);
	print_node(target.node);
	puts("Deleting the first occurrence of 5...");
	target = search(root, 5);
	delete_node(root, 5);
	fputs("Now it's garbage: ",stdout);
	print_node(target.node);
	print_list(root);
	puts("Deleting the first item by index,");
	delete_node_at(root, 0);
	puts("and the new first item by value...");
	delete_node(root, 3);
	printf("The head is still at %p.\n",root);
	print_list(root);
	puts("Deleting list...");
	delete_list(root);
	puts("Now it's garbage (or at least probably not data):");
	print_list(root);

	return 0;
}
